import {
  Dialog,
  DialogContent,
  DialogFooter,
  DialogHeader,
  DialogTitle
} from '@/components/ui/dialog';
import { Button } from '@/components/ui/button';
import { Alert, useDataGrid } from '@/components';
import { useCallback, useState } from 'react';
import { apiConfig } from '@/config/api.config';
import { toast } from 'sonner';
import { useCallApi } from '@/hooks';
import { useManageTransferTypeContext } from '../hooks/useManageTransferTypeContext';
import { DialogDescription } from '@radix-ui/react-dialog';
import { doSaveLogActivity } from '@/actions/GlobalActions';

const API_URL = apiConfig.service_transaction;

const DeleteDialog = () => {
  const { showDeleteDialog, handleDeleteDialog, selectedTransferType } =
    useManageTransferTypeContext();
  const { reload } = useDataGrid();
  const { DeleteData } = useCallApi();
  const [alert, setAlert] = useState({
    show: false,
    message: ''
  });

  const doDeleteTransferType = useCallback(async () => {
    if (!selectedTransferType) {
      toast.error('No Transfer Type selected');
      return;
    }

    const response = await DeleteData(
      `${API_URL}/transactiontype/delete/${selectedTransferType}/false`,
      {
        id: selectedTransferType
      }
    );

    if (response?.status) {
      setAlert({ show: false, message: '' });
      handleDeleteDialog(false, null);
      reload();
      const createActivity = {
        module: 'Manage Transfer Type',
        description: `Delete Transfer Type => ${selectedTransferType}`,
        action: 'D'
      };
      doSaveLogActivity(createActivity);
      // setTimeout(() => toast.success('Success Delete Transaction Type'), 0);
    } else {
      setAlert({ show: true, message: response?.message });
      // setTimeout(() => toast.error('Failed Delete Product'), 0);
    }
  }, [selectedTransferType]);
  return (
    <Dialog open={showDeleteDialog} onOpenChange={(open) => handleDeleteDialog(open, null)}>
      <DialogContent className="container-fixed max-w-md flex flex-col p-5 overflow-hidden [&>button]:hidden">
        <DialogHeader className="p-0 border-0 block">
          <DialogTitle className="text-lg">Delete Transfer Type</DialogTitle>
          <DialogDescription className="text-sm">
            Are you sure you want to delete this data?
          </DialogDescription>
          <Alert variant="warning">
            <h3 className="text-lg">Are you sure?</h3>
            <span className="text-sm">You will delete this data!</span>
          </Alert>
          {alert.show && (
            <Alert variant="danger">
              <h3>{alert.message}</h3>
            </Alert>
          )}
        </DialogHeader>
        <DialogFooter className="flex justify-end items-center gap-4 mt-3">
          <Button variant={'outline'} onClick={() => handleDeleteDialog(false, null)}>
            Cancel
          </Button>
          <Button variant={'destructive'} onClick={() => doDeleteTransferType()}>
            Delete
          </Button>
        </DialogFooter>
      </DialogContent>
    </Dialog>
  );
};

export default DeleteDialog;
